Subject: modifications to the InterpretDebug patch

---

 makefiles/Makefile.bertw |    3 
 source/interpret.c       |  249 ++++++++++++++++++++++++++++++++---------------
 source/interpret.h       |    5 
 source/parse.y           |   14 --
 source/userCmds.c        |    4 
 5 files changed, 184 insertions(+), 91 deletions(-)

diff --quilt old/source/interpret.c new/source/interpret.c
--- old/source/interpret.c
+++ new/source/interpret.c
@@ -112,23 +112,24 @@ static const char *tagToStr(enum typeTag
 
 #if defined(DEBUG_ASSEMBLY) || defined(DEBUG_STACK)
 #define DEBUG_DISASSEMBLER
-static const char *printd(const char *f, ...);
-static int outPrintd();
-static void disasm(Inst *inst, int nInstr);
+static const char *printd(const char *f, ...)
+__attribute__((__format__(printf,1,2)));
+static int outPrintd(void);
+static void disasm(const char *name, Inst *inst, int nInstr);
 static void disasmInternal(Inst *inst, int nInstr);
 #endif /* #if defined(DEBUG_ASSEMBLY) || defined(DEBUG_STACK) */
 
 #ifdef DEBUG_ASSEMBLY   /* for disassembly */
-#define DISASM(i, n)    disasm(i, n)
+#define DISASM(name, i, n)    disasm(name, i, n)
 #else /* #ifndef DEBUG_ASSEMBLY */
-#define DISASM(i, n)
+#define DISASM(name, i, n)
 #endif /* #ifndef DEBUG_ASSEMBLY */
 
 #ifdef DEBUG_STACK      /* for run-time instruction and stack trace */
 static void stackdump(int n, int extra);
 static void stackdumpInternal(int n, int extra);
 #define STACKDUMP(n, x) stackdump(n, x)
-#define DISASM_RT(i, n) disasm(i, n)
+#define DISASM_RT(i, n) disasm(NULL, i, n)
 #else /* #ifndef DEBUG_STACK */
 #define STACKDUMP(n, x)
 #define DISASM_RT(i, n)
@@ -161,6 +162,8 @@ static Inst *ProgP;			 /* next free spot
 static Inst *LoopStack[LOOP_STACK_SIZE]; /* addresses of break, cont stmts */
 static Inst **LoopStackPtr = LoopStack;  /*  to fill at the end of a loop */
 
+static const char *ProgramName = "";
+
 /* Global data for the interpreter */
 static DataValue *TheStack;	    /* the stack */
 static DataValue *StackP;	    /* next free spot on stack */
@@ -253,7 +256,7 @@ void InitMacroGlobals(void)
 ** Start collecting instructions for a program. Clears the program
 ** and the symbol table.
 */
-void BeginCreatingProgram(AccumulatorData *acc)
+void BeginCreatingProgram(const char *name, AccumulatorData *acc)
 {
     /* save state */
     acc->localSymList = LocalSymList;
@@ -261,10 +264,12 @@ void BeginCreatingProgram(AccumulatorDat
     acc->progP = ProgP;
     memcpy(acc->loopStack, LoopStack, sizeof(*LoopStack) * LOOP_STACK_SIZE);
     acc->loopStackPtr = LoopStackPtr;
+    acc->name = ProgramName;
 
     LocalSymList = NULL;
     ProgP = Prog;
     LoopStackPtr = LoopStack;
+    ProgramName = name;
 }
 
 /*
@@ -278,12 +283,13 @@ Program *FinishCreatingProgram(Accumulat
     int progLen, fpOffset = 0;
     Symbol *s;
     
-    newProg = (Program *)XtMalloc(sizeof(Program));
+    newProg = XtNew(Program);
+    newProg->name = XtMalloc(strlen(ProgramName) + 1); /* +1 for '\0' */
     progLen = ((char *)ProgP) - ((char *)Prog);
     newProg->code = (Inst *)XtMalloc(progLen);
     memcpy(newProg->code, Prog, progLen);
     newProg->localSymList = LocalSymList;
-    newProg->name = NULL;
+    strcpy(newProg->name, ProgramName);
     newProg->refcount = 1;
     
     /* Local variables' values are stored on the stack.  Here we assign
@@ -291,7 +297,7 @@ Program *FinishCreatingProgram(Accumulat
     for (s = newProg->localSymList; s != NULL; s = s->next)
 	s->value.val.n = fpOffset++;
     
-    DISASM(newProg->code, ProgP - Prog);
+    DISASM(newProg->name, newProg->code, ProgP - Prog);
     
     /* restore state */
     LocalSymList = acc->localSymList;
@@ -299,6 +305,7 @@ Program *FinishCreatingProgram(Accumulat
     ProgP = acc->progP;
     memcpy(LoopStack, acc->loopStack, sizeof(*LoopStack) * LOOP_STACK_SIZE);
     LoopStackPtr = acc->loopStackPtr;
+    ProgramName = acc->name;
 
     return newProg;
 }
@@ -3588,7 +3595,9 @@ static int errCheck(const char *s)
 */
 static char *stackDumpStr(DataValue *fp, const char *msg, char **s, int *pLen)
 {
-    int len;
+    static const char backtraceMsg[] = "\n\nBacktrace:";
+    char frameBuf[TYPE_INT_STR_SIZE(int) + 2];
+    int len, nFrames, frameWidth, thisFrameWidth;
     const char *op;
     char *np;
     DataValue *nfp = fp;
@@ -3596,26 +3605,30 @@ static char *stackDumpStr(DataValue *fp,
 
 #ifdef DEBUG_STACK
     const char *dump;
-    printd("\n\n");
+    static const char stackdumpMsg[] = "\n\nStack:\n";
     disasmInternal(PC - 1, 1);
     stackdumpInternal(0, 50);
     dump = printd(NULL);
 #endif
 
     /* first measure the lengths */
-    len = strlen(msg) + 1;
+    len = strlen(msg) + strlen(backtraceMsg) + 1;
     nfp = fp;
+    nFrames = 0;
     do {
+        nFrames++;
         len = len + FP_GET_ITEM(nfp, FP_FUNCTION_NAME).val.str.len + 1;
         pc = FP_GET_RET_PC(nfp);
         nfp = FP_GET_OLD_FP(nfp);
     } while (pc);
+    frameWidth = lenLongAsStr(nFrames);
+    len += nFrames * (2 + frameWidth);
 #ifdef DEBUG_STACK
-    len += strlen(dump);
+    len += strlen(stackdumpMsg) + strlen(dump);
 #endif
     if (*pLen < len)
     {
-        *s = *s ? XtRealloc(*s, len) : XtMalloc(len);
+        *s = XtRealloc(*s, len);
         *pLen = len;
     }
     /* now copy */
@@ -3623,10 +3636,25 @@ static char *stackDumpStr(DataValue *fp,
     op = msg;
     while (*op)
         *np++ = *op++;
+    op = backtraceMsg;
+    while (*op)
+        *np++ = *op++;
 
     nfp = fp;
+    nFrames = 0;
     do {
+        nFrames++;
         *np++ = '\n';
+        *np++ = '#';
+        thisFrameWidth = 0;
+        op = longAsStr(nFrames);
+        while (*op) {
+            thisFrameWidth++;
+            *np++ = *op++;
+        }
+        while (thisFrameWidth++ < frameWidth)
+            *np++ = ' ';
+        *np++ = ' ';
         op = FP_GET_ITEM(nfp, FP_FUNCTION_NAME).val.str.rep;
         while (*op)
             *np++ = *op++;
@@ -3634,12 +3662,15 @@ static char *stackDumpStr(DataValue *fp,
         nfp = FP_GET_OLD_FP(nfp);
     } while (pc);
 #ifdef DEBUG_STACK
+    op = stackdumpMsg;
+    while (*op)
+        *np++ = *op++;
     op = dump;
     while (*op)
         *np++ = *op++;
 #endif
 
-    *np = 0;
+    *np = '\0';
     return *s;
 }
 
@@ -3754,27 +3785,27 @@ static const char *printd(const char *f,
     return printdBuffer;
 }
 
-int outPrintd()
+int outPrintd(void)
 {
     const char *s = printd(NULL);
     const char *cp;
 
     static int outIsTTY = -1;
     if (outIsTTY == -1)
-      outIsTTY = isatty(fileno(stdout));
+      outIsTTY = isatty(fileno(stderr));
 
     if (outIsTTY)
     {
         for (cp = s; *cp; cp++)
             if (*cp == '\n')
-                printf("\033[K\n");
+                fprintf(stderr, "\033[K\n");
             else
-                putchar(*cp);
+                fputc(*cp, stderr);
     }
     else
     {
         for (cp = s; *cp; cp++)
-            putchar(*cp);
+            fputc(*cp, stderr);
     }
     return cp - s;
 }
@@ -3785,40 +3816,59 @@ static void dumpVal(DataValue dv)
 {
     switch (dv.tag) {
         case INT_TAG:
-            printd("i=%d", dv.val.n);
+            printd(" <%s %d>", tagToStr(INT_TAG), dv.val.n);
             break;
         case STRING_TAG:
             {
-                int k;
-                char s[21];
-                char *src = dv.val.str.rep;
+                int k, l;
+                char s[64];
+                const char *src = dv.val.str.rep;
+                unsigned len = dv.val.str.len;
                 if (!src) {
-                    printd("s=<NULL>");
+                    printd(" <%s NULL>", tagToStr(STRING_TAG));
                 }
                 else {
-                    for (k = 0; src[k] && k < sizeof s - 1; k++) {
-                        s[k] = isprint(src[k]) ? src[k] : '?';
+                    for (k = 0, l = 0; src[k] && l < sizeof s - 1; k++, l++) {
+                        char *e;
+                        const char to[] = "\\\"ntbrfave";
+#ifdef EBCDIC_CHARSET
+                        const char from[] = "\\\"\n\t\b\r\f\a\v\x27"; /* EBCDIC escape */
+#else
+                        const char from[] = "\\\"\n\t\b\r\f\a\v\x1B"; /* ASCII escape */
+#endif
+                        if ((e = strchr(from, src[k]))) {
+                            if (l < sizeof s - 2) {
+                                s[l++] = '\\';
+                                s[l]   = to[e - from];
+                            }
+                        }
+                        else if (isprint(src[k])) {
+                            s[l] = src[k];
+                        }
+                        else {
+                            s[l] = '?';
+                        }
                     }
-                    s[k] = 0;
-                    printd("s=\"%s\"%s[%d]", s,
-                           src[k] ? "..." : "", strlen(src));
+                    s[l] = 0;
+                    printd(" <%s %u:\"%s\"%s>", tagToStr(STRING_TAG),
+                            len, s, src[k] ? "..." : "");
                 }
             }
             break;
         case ARRAY_TAG:
-            printd("%08p <%s>[%d]", dv.val.arrayPtr, tagToStr(ARRAY_TAG),
-                    ArraySize(&dv));
+            printd(" <%s %u:%p>", tagToStr(ARRAY_TAG), ArraySize(&dv),
+                    dv.val.arrayPtr);
             break;
         case NO_TAG:
-            if (!dv.val.inst) {
-                printd("<%s>", tagToStr(NO_TAG));
+            if (!*(void **)&dv.val) {
+                printd(" <%s>", tagToStr(NO_TAG));
             }
             else {
-                printd("?%8p", dv.val.inst);
+                printd(" ?%p", *(void **)&dv.val);
             }
             break;
         default:
-            printd("UNKNOWN DATA TAG %d ?%8p", dv.tag, dv.val.inst);
+            printd(" <unknown value %d:%p>", dv.tag, *(void **)&dv.val);
             break;
     }
 }
@@ -3833,57 +3883,65 @@ static void disasmInternal(Inst *inst, i
 #undef OP
     };
     int i, j;
+    static size_t opLen;
     
-    printd("\n");
+    if (!opLen) {
+        for (j = 0; j < N_OPS; ++j) {
+            if (opLen < strlen(opNames[j])) {
+                opLen = strlen(opNames[j]);
+            }
+        }
+    }
+
     for (i = 0; i < nInstr; ++i) {
-        printd("Prog %8p ", &inst[i]);
+        printd("Prog %10p", &inst[i]);
         for (j = 0; j < N_OPS; ++j) {
             if (inst[i].func == OpFns[j]) {
-                printd("%22s ", opNames[j]);
+                printd(" %*s", (int)opLen, opNames[j]);
                 if (j == OP_PUSH_SYM || j == OP_ASSIGN) {
                     Symbol *sym = inst[i+1].sym;
-                    printd("%s", sym->name);
-                    if (sym->value.tag == STRING_TAG &&
-                        strncmp(sym->name, "string #", 8) == 0) {
+                    printd(" %s", sym->name);
+                    if (sym->type == CONST_SYM
+                            && sym->value.tag == STRING_TAG) {
                         dumpVal(sym->value);
                     }
                     ++i;
                 }
                 else if (j == OP_PUSH_IMMED) {
-                    printd("i=%d", inst[i+1].value);
+                    printd(" <immediate %d>", inst[i+1].value);
                     ++i;
                 }
                 else if (j == OP_BRANCH || j == OP_BRANCH_FALSE ||
                         j == OP_BRANCH_NEVER || j == OP_BRANCH_TRUE) {
-                    printd("to=(%d) %p", inst[i+1].value,
+                    printd(" to=(%+d) %p", inst[i+1].value,
                             &inst[i+1] + inst[i+1].value);
                     ++i;
                 }
                 else if (j == OP_CONCAT) {
-                    printd("nExpr=%d", inst[i+1].value);
+                    printd(" nExpr=%d", inst[i+1].value);
                     ++i;
                 }
                 else if (j == OP_SUBR_CALL) {
                     int args = inst[i+2].value;
-                    printd("%s ", inst[i+1].sym->name);
+                    printd(" %s", inst[i+1].sym->name);
                     if (args < 0) {
-                        printd("%d+args[] (%d)", -args - 1, args);
+                        printd(" %d+args[] (%d)", -args - 1, args);
                     }
                     else {
-                        printd("%d args", args);
+                        printd(" %d args", args);
                     }
                     i += 2;
                 }
                 else if (j == OP_SUBR_CALL_STACKED_N) {
-                    printd("%s args[] (?)", inst[i+1].sym->name);
+                    printd(" %s args[] (?)", inst[i+1].sym->name);
                     ++i;
                 }
                 else if (j == OP_BEGIN_ARRAY_ITER) {
-                    printd("%s in", inst[i+1].sym->name);
+                    printd(" %s in", inst[i+1].sym->name);
                     ++i;
                 }
                 else if (j == OP_ARRAY_ITER) {
-                    printd("%s = %s++ end-loop=(%d) %p",
+                    printd(" %s = %s++ end-loop=(%+d) %p",
                             inst[i+1].sym->name,
                             inst[i+2].sym->name,
                             inst[i+3].value, &inst[i+3] + inst[i+3].value);
@@ -3895,18 +3953,20 @@ static void disasmInternal(Inst *inst, i
                          j == OP_ANONARRAY_INDEX_VAL ||
                          j == OP_NAMED_ARG1 ||
                          j == OP_NAMED_ARGN) {
-                    printd("nDim=%d", inst[i+1].value);
+                    printd(" nDim=%d", inst[i+1].value);
                     ++i;
                 }
                 else if (j == OP_ARRAY_REF_ASSIGN_SETUP) {
-                    printd("binOp=%s ", inst[i+1].value ? "true" : "false");
-                    printd("nDim=%d", inst[i+2].value);
+                    printd(" binOp=%s nDim=%d",
+                            inst[i+1].value ? "true" : "false",
+                            inst[i+2].value);
                     i += 2;
                 }
                 else if (j == OP_PUSH_ARRAY_SYM) {
-                    printd("%s", inst[++i].sym->name);
-                    printd(" %s", inst[i+1].value ? "createAndRef" : "refOnly");
-                    ++i;
+                    printd(" %s %s",
+                            inst[i+1].sym->name,
+                            inst[i+2].value ? "createAndRef" : "refOnly");
+                    i += 2;
                 }
 
                 printd("\n");
@@ -3914,18 +3974,20 @@ static void disasmInternal(Inst *inst, i
             }
         }
         if (j == N_OPS) {
-            printd("%x\n", inst[i].value);
+            printd(" %x\n", inst[i].value);
         }
     }
 }
 
-static void disasm(Inst *inst, int nInstr)
+static void disasm(const char *name, Inst *inst, int nInstr)
 {
     static int outIsTTY = -1;
-    if (outIsTTY == -1) outIsTTY = isatty(fileno(stdout));
+    if (outIsTTY == -1) outIsTTY = isatty(fileno(stderr));
     if (outIsTTY) { printd("\033[H"); }
+    if (name) printd(">> %s\n", name);
     disasmInternal(inst, nInstr);
     if (outIsTTY) { printd("\033[J\n"); }
+    if (name) printd("\n");
     outPrintd();
 }
 #endif /* #ifdef DEBUG_DISASSEMBLER */
@@ -3938,7 +4000,11 @@ static void stackdumpframe(DataValue *ar
     Inst *retPC = FP_GET_RET_PC(fp);
     DataValue *oldFP = retPC ? FP_GET_OLD_FP(fp) : NULL;
     DataValue *arg1 = &FP_GET_ARG_N(fp, 0);
+    DataValue *argc = &FP_GET_ITEM(fp, FP_ARG_COUNT_INDEX);
     DataValue *fnNm = &FP_GET_ITEM(fp, FP_FUNCTION_NAME);
+    DataValue *prFP = &FP_GET_ITEM(fp, FP_PROG_INDEX);
+    DataValue *ofFP = &FP_GET_ITEM(fp, FP_OLD_FP_INDEX);
+    DataValue *rpFP = &FP_GET_ITEM(fp, FP_RET_PC_INDEX);
     DataValue *dv;
     DataValue *endDv = (arg1 > outpt) ? arg1 : outpt;
     int nArgs = FP_GET_ARG_COUNT(fp);
@@ -3976,17 +4042,16 @@ static void stackdumpframe(DataValue *ar
     for (dv = endDv; dv < sp; dv++)
 #endif /* #ifdef DEBUG_STACK_HEADFIRST */
     {
-        const char *posFmt = "%-6s ";
+        const char *posFmt = "%-6s";
         const char *symName = "";
 
         char *pos = "";
         char buffer[sizeof(STACK_DUMP_ARG_PREFIX) + TYPE_INT_STR_SIZE(int)];
         int offset = dv - fp;
-        const char *leadIn = (dv >= arrow) ? ">>>>" :
-                             (dv ==  arg1) ? "----" :
-                             (dv ==  fnNm) ? "====" : "";
-        printd("%4.4s", leadIn);
-        printd("%8p%c", dv, topMark);
+        const char *leadIn = (dv >= arrow) ? ">>>>>" :
+                             (dv ==  arg1) ? "---->" :
+                             (dv ==  argc) ? "====>" : "";
+        printd("%5.5s%10p%c", leadIn, dv, topMark);
         switch (offset) {
             case FP_ARG_COUNT_INDEX: pos = "NArgs";  break; /* num. arguments */
             case FP_FUNCTION_NAME:   pos = "FnName"; break;
@@ -4004,10 +4069,7 @@ static void stackdumpframe(DataValue *ar
                 }
                 else if (0 <= offset && offset < nSyms) {
                     sprintf(pos = buffer, offset ? "[%d]" : "FP[%d]", offset);
-                    posFmt = "%6s ";
-                }
-                else if (offset == 0) {
-                    pos = "FrameP";
+                    posFmt = "%6s";
                 }
                 break;
         }
@@ -4022,12 +4084,39 @@ static void stackdumpframe(DataValue *ar
                 }
             }
         }
-        printd("%-*.*s ", symLen, symLen, symName);
+        printd(" %-*.*s", symLen, symLen, symName);
 
-        if (dv == fnNm && dv->tag == STRING_TAG && dv->val.str.rep)
-            printd("%s", dv->val.str.rep);
+        if (dv == fnNm && dv->tag == STRING_TAG && dv->val.str.rep) {
+            printd(" %s", dv->val.str.rep);
+        }
+        else
+        if (dv == ofFP) {
+            if (dv->val.dataval) {
+                printd(" %p", dv->val.dataval);
+            }
+            else {
+                printd(" <end>");
+            }
+        }
+        else
+        if (dv == rpFP) {
+            if (dv->val.inst) {
+                printd(" %p", dv->val.inst);
+            }
+            else {
+                printd(" <end>");
+            }
+        }
         else
+        if (dv == prFP) {
+            Program *prog = dv->val.prog;
+            printd(" <%s:%u %p>",
+                    prog->name, prog->refcount,
+                    prog);
+        }
+        else {
             dumpVal(*dv);
+        }
 
         printd("\n");
     }
@@ -4054,7 +4143,7 @@ static void stackdumpInternal(int n, int
     if (outpt < TheStack)
         printd("--------------Stack base--------------\n");
     stackdumpframe(arrow, outpt, FrameP, StackP, '*');
-    printd("Stack ----->\n");
+    printd("Stack ----->\n\n");
 #endif /* #ifdef DEBUG_STACK_HEADFIRST */
 }
 
@@ -4062,15 +4151,19 @@ static void stackdump(int n, int extra)
 {
     static int outIsTTY = -1;
     if (outIsTTY == -1)
-        outIsTTY = isatty(fileno(stdout));
+        outIsTTY = isatty(fileno(stderr));
 
-    stackdumpInternal(n, extra);
+#ifndef DEBUG_STACKDUMP_EXTRA
+#define DEBUG_STACKDUMP_EXTRA 0
+#endif
+    stackdumpInternal(n, extra + DEBUG_STACKDUMP_EXTRA);
+#undef DEBUG_STACKDUMP_EXTRA
 
     if (outIsTTY)
         printd("\033[J\n");
 
     outPrintd();
-    fflush(stdout);
+    fflush(stderr);
 }
 
 #endif /* ifdef DEBUG_STACK */
diff --quilt old/source/interpret.h new/source/interpret.h
--- old/source/interpret.h
+++ new/source/interpret.h
@@ -105,10 +105,10 @@ typedef struct SymbolRec {
 } Symbol;
 
 typedef struct ProgramTag {
+    char *name;
     Symbol *localSymList;
     Inst *code;
     unsigned refcount;
-    char *name;
 } Program;
 
 /* Information needed to re-start a preempted macro */
@@ -128,6 +128,7 @@ typedef struct AccumulatorDataTag {
     Inst *progP;
     Inst *loopStack[LOOP_STACK_SIZE];
     Inst **loopStackPtr;
+    const char *name;
 } AccumulatorData;
 
 void InitMacroGlobals(void);
@@ -144,7 +145,7 @@ int ArrayCopy(DataValue *dstArray, DataV
 
 /* Routines for creating a program, (accumulated beginning with
    BeginCreatingProgram and returned via FinishCreatingProgram) */
-void BeginCreatingProgram(AccumulatorData *acc);
+void BeginCreatingProgram(const char *name, AccumulatorData *acc);
 int AddOp(int op, char **msg);
 int AddSym(Symbol *sym, char **msg);
 int AddImmediate(int value, char **msg);
diff --quilt old/source/parse.y new/source/parse.y
--- old/source/parse.y
+++ new/source/parse.y
@@ -196,7 +196,7 @@ definesym:  SYMBOL {
                     yyerror("try to override built-in subroutine"); YYERROR;
                 }
                 $$.sym = PromoteToGlobal($1);
-                BeginCreatingProgram($$.acc);
+                BeginCreatingProgram($$.sym->name, $$.acc);
             }
             ;
 define:     definekw blank definesym blank blockwb {
@@ -745,14 +745,16 @@ Program *ParseMacro(char *expr, char **m
 {
     Program *prog;
     AccumulatorData *acc = XtNew(AccumulatorData);
-    static const char *prefix = ">> ";
 
 #if YYDEBUG
     int oldyydebug = yydebug;
     yydebug = 1;
 #endif
 
-    BeginCreatingProgram(acc);
+    if (!name)
+        name = "--unknown--";
+
+    BeginCreatingProgram(name, acc);
 
     /* whether we allow the "define" keyword */
     AllowDefine = allowDefine;
@@ -780,12 +782,6 @@ Program *ParseMacro(char *expr, char **m
     prog = FinishCreatingProgram(acc);
     XtFree((char *)acc);
 
-    if (!name)
-        name = "--unknown--";
-
-    prog->name = XtMalloc(strlen(name) + strlen(prefix) + 1);
-    strcat(strcpy(prog->name, prefix), name);
-
     /* parse succeeded */
     *msg = "";
     *stoppedAt = InPtr;
diff --quilt old/source/userCmds.c new/source/userCmds.c
--- old/source/userCmds.c
+++ new/source/userCmds.c
@@ -1286,13 +1286,13 @@ static int doMacroMenuCmd(WindowInfo *wi
 int DoNamedMacroMenuCmd(WindowInfo *window, const char *itemName)
 {
     return doMacroMenuCmd(window, itemName, MacroMenuItems, NMacroMenuItems,
-                          "macro-menu>");
+                          "Macro Menu>");
 }
 
 int DoNamedBGMenuCmd(WindowInfo *window, const char *itemName)
 {
     return doMacroMenuCmd(window, itemName, BGMenuItems, NBGMenuItems,
-                          "background-menu>");
+                          "Background Menu>");
 }
 
 /*
diff --quilt old/makefiles/Makefile.bertw new/makefiles/Makefile.bertw
--- old/makefiles/Makefile.bertw
+++ new/makefiles/Makefile.bertw
@@ -24,6 +24,9 @@ ifdef DEBUG
   ifdef DEBUG_MACRO
     ifndef DEBUG_NO_STACKDUMP
       CFLAGS += -DDEBUG_STACK
+      ifdef DEBUG_STACKDUMP_EXTRA
+        CFLAGS += -DDEBUG_STACKDUMP_EXTRA=$(DEBUG_STACKDUMP_EXTRA)
+      endif
     endif
     ifndef DEBUG_NO_DISASM
       CFLAGS += -DDEBUG_ASSEMBLY
